#include "chip.h"
#include <stdlib.h>

typedef struct {
    t_chip_per_id id;
    __IO uint32_t *clk_reg;
    uint32_t clk_bit;
    __IO uint32_t *rst_reg;
    uint32_t rst_bit;
} t_per_regs;


static const t_per_regs f_per_regs[] = {
    {CHIP_PER_ID_MDMA,      &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_MDMAEN,    &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_MDMARST},
    {CHIP_PER_ID_DMA2D,     &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_DMA2DEN,   &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_DMA2DRST},
#if CHIP_DEV_SUPPORT_JPGDEC
    {CHIP_PER_ID_JPGDEC,    &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_JPGDECEN,  &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_JPGDECRST},
#endif
#if CHIP_CLK_EXMC_KER_SRC_EN
    {CHIP_PER_ID_EXMC,      &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_EXMCEN,    &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_EXMCRST},
#endif
#if CHIP_CLK_OCTOSPI_KER_SRC_EN
    {CHIP_PER_ID_OCTOSPI1,  &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_OCTOSPI1EN,    &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_OCTOSPI1RST},
    {CHIP_PER_ID_OCTOSPI2,  &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_OCTOSPI2EN,    &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_OCTOSPI2RST},
    {CHIP_PER_ID_IOMNGR,    &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_IOMNGREN,      &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_IOMNGRRST},
    {CHIP_PER_ID_OTFD1,     &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_OTFD1EN,       &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_OTFD1RST},
    {CHIP_PER_ID_OTFD2,     &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_OTFD2EN,       &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_OTFD2RST},
#endif
#if CHIP_CLK_QSPI_KER_SRC_EN
    {CHIP_PER_ID_QSPI,      &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_QSPIEN,    &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_QSPIRST},
#endif
#if CHIP_CLK_SDMMC_KER_SRC_EN
    {CHIP_PER_ID_SDMMC1,    &CHIP_REGS_RCC->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_SDMMC1EN,  &CHIP_REGS_RCC->AHB3RSTR, CHIP_REGFLD_RCC_AHB3RSTR_SDMMC1RST},
#endif
#if CHIP_DEV_SUPPORT_CORE_CM4
    {CHIP_PER_ID_CM4_FLASH, &CHIP_REGS_RCC_C2->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_FLITFEN, NULL, 0},
    {CHIP_PER_ID_CM4_DTCM1, &CHIP_REGS_RCC_C2->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_DTCM1EN, NULL, 0},
    {CHIP_PER_ID_CM4_DTCM2, &CHIP_REGS_RCC_C2->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_DTCM2EN, NULL, 0},
    {CHIP_PER_ID_CM4_ITCM,  &CHIP_REGS_RCC_C2->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_ITCMEN,  NULL, 0},
    {CHIP_PER_ID_CM4_AXISRAM, &CHIP_REGS_RCC_C2->AHB3ENR, CHIP_REGFLD_RCC_AHB3ENR_AXISRAMEN, NULL, 0},
#endif
    {CHIP_PER_ID_DMA1,      &CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_DMA1EN,    &CHIP_REGS_RCC->AHB1RSTR, CHIP_REGFLD_RCC_AHB1RSTR_DMA1RST},
    {CHIP_PER_ID_DMA2,      &CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_DMA2EN,    &CHIP_REGS_RCC->AHB1RSTR, CHIP_REGFLD_RCC_AHB1RSTR_DMA2RST},
#if CHIP_CLK_ADC_KER_SRC_EN || CHIP_CLK_ADC1_2_SCLK_EN
    {CHIP_PER_ID_ADC1_2,    &CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_ADC12EN,   &CHIP_REGS_RCC->AHB1RSTR, CHIP_REGFLD_RCC_AHB1RSTR_ADC12RST},
#endif
#if CHIP_DEV_SUPPORT_CORE_CM4
    {CHIP_PER_ID_ART,       &CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_ARTEN,     &CHIP_REGS_RCC->AHB1RSTR, CHIP_REGFLD_RCC_AHB1RSTR_ARTRST},
#endif
    {CHIP_PER_ID_ETH1_MAC,  &CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_ETH1MACEN, &CHIP_REGS_RCC->AHB1RSTR, CHIP_REGFLD_RCC_AHB1RSTR_ETH1MACRST},
    {CHIP_PER_ID_ETH1_TX,   &CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_ETH1TXEN,  NULL, 0},
    {CHIP_PER_ID_ETH1_RX,   &CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_ETH1RXEN,  NULL, 0},
#if CHIP_CLK_USB_KER_SRC_EN
    {CHIP_PER_ID_USB1_OTGHS,&CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_USB1OTGHSEN, &CHIP_REGS_RCC->AHB1RSTR, CHIP_REGFLD_RCC_AHB1RSTR_USB1OTGHSRST},
#if CHIP_DEV_SUPPORT_USB2
    {CHIP_PER_ID_USB2_OTGHS,&CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_USB2OTGHSEN, &CHIP_REGS_RCC->AHB1RSTR, CHIP_REGFLD_RCC_AHB1RSTR_USB2OTGHSRST},
#endif
#endif
    {CHIP_PER_ID_USB1_OTGHS_ULPI,&CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_USB1OTGHSULPIEN, NULL, 0},
#if CHIP_DEV_SUPPORT_USB2
    {CHIP_PER_ID_USB2_OTGHS_ULPI,&CHIP_REGS_RCC->AHB1ENR, CHIP_REGFLD_RCC_AHB1ENR_USB2OTGHSULPIEN, NULL, 0},
#endif
    {CHIP_PER_ID_DVP,       &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_CAMITFEN,  &CHIP_REGS_RCC->AHB2RSTR, CHIP_REGFLD_RCC_AHB2RSTR_CAMITFRST},
    {CHIP_PER_ID_CRYPT,     &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_CRYPEN,    &CHIP_REGS_RCC->AHB2RSTR, CHIP_REGFLD_RCC_AHB2RSTR_CRYPRST},
    {CHIP_PER_ID_HASH,      &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_HASHEN,    &CHIP_REGS_RCC->AHB2RSTR, CHIP_REGFLD_RCC_AHB2RSTR_HASHRST},
#if CHIP_CLK_RNG_KER_SRC_EN
    {CHIP_PER_ID_RNG,       &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_RNGEN,     &CHIP_REGS_RCC->AHB2RSTR, CHIP_REGFLD_RCC_AHB2RSTR_RNGRST},
#endif
#if CHIP_CLK_SDMMC_KER_SRC_EN
    {CHIP_PER_ID_SDMMC2,    &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_SDMMC2EN,  &CHIP_REGS_RCC->AHB2RSTR, CHIP_REGFLD_RCC_AHB2RSTR_SDMMC2RST},
#endif
#if CHIP_DEV_SUPPORT_FMAC
    {CHIP_PER_FMAC,         &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_FMACEN,  &CHIP_REGS_RCC->AHB2RSTR, CHIP_REGFLD_RCC_AHB2RSTR_FMACRST},
#endif
#if CHIP_DEV_SUPPORT_CORDIC
    {CHIP_PER_CORDIC,       &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_CORDICEN,  &CHIP_REGS_RCC->AHB2RSTR, CHIP_REGFLD_RCC_AHB2RSTR_CORDICRST},
#endif
    {CHIP_PER_ID_SRAM1,     &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_SRAM1EN,   NULL, 0},
    {CHIP_PER_ID_SRAM2,     &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_SRAM2EN,   NULL, 0},
#if CHIP_DEV_SUPPORT_SRAM3
    {CHIP_PER_ID_SRAM3,     &CHIP_REGS_RCC->AHB2ENR, CHIP_REGFLD_RCC_AHB2ENR_SRAM3EN,   NULL, 0},
#endif
    {CHIP_PER_ID_GPIOA,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOAEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOARST},
    {CHIP_PER_ID_GPIOB,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOBEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOBRST},
    {CHIP_PER_ID_GPIOC,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOCEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOCRST},
    {CHIP_PER_ID_GPIOD,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIODEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIODRST},
    {CHIP_PER_ID_GPIOE,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOEEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOERST},
    {CHIP_PER_ID_GPIOF,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOFEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOFRST},
    {CHIP_PER_ID_GPIOG,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOGEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOGRST},
    {CHIP_PER_ID_GPIOH,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOHEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOHRST},
#if CHIP_DEV_SUPPORT_PORTI
    {CHIP_PER_ID_GPIOI,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOIEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOIRST},
#endif
    {CHIP_PER_ID_GPIOJ,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOJEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOJRST},
    {CHIP_PER_ID_GPIOK,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOKEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOKRST},
    {CHIP_PER_ID_GPIOK,     &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_GPIOKEN,   &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_GPIOKRST},
    {CHIP_PER_ID_CRC,       &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_CRCEN,     &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_CRCRST},
    {CHIP_PER_ID_BDMA,      &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_BDMAEN,    &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_BDMARST},
#if CHIP_CLK_ADC_KER_SRC_EN || CHIP_CLK_ADC3_SCLK_EN
    {CHIP_PER_ID_ADC3,      &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_ADC3EN,    &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_ADC3RST},
#endif
    {CHIP_PER_ID_HSEM,      &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_HSEMEN,    &CHIP_REGS_RCC->AHB4RSTR, CHIP_REGFLD_RCC_AHB4RSTR_HSEMRST},
    {CHIP_PER_ID_BKPRAM,    &CHIP_REGS_RCC->AHB4ENR, CHIP_REGFLD_RCC_AHB4ENR_BKPRAMEN,  NULL, 0},
    {CHIP_PER_ID_LTDCEN,    &CHIP_REGS_RCC->APB3ENR, CHIP_REGFLD_RCC_APB3ENR_LTDCEN,    &CHIP_REGS_RCC->APB3RSTR, CHIP_REGFLD_RCC_APB3RSTR_LTDCRST},
#if CHIP_CLK_DSI_KER_SRC_EN
    {CHIP_PER_ID_DSI,       &CHIP_REGS_RCC->APB3ENR, CHIP_REGFLD_RCC_APB3ENR_DSIEN,     &CHIP_REGS_RCC->APB3RSTR, CHIP_REGFLD_RCC_APB3RSTR_DSIRST},
#endif
    {CHIP_PER_ID_WWDG1,     &CHIP_REGS_RCC->APB3ENR, CHIP_REGFLD_RCC_APB3ENR_WWDG1EN,   NULL, 0},
    {CHIP_PER_ID_TIM2,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM2EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM2RST},
    {CHIP_PER_ID_TIM3,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM3EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM3RST},
    {CHIP_PER_ID_TIM4,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM4EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM4RST},
    {CHIP_PER_ID_TIM5,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM5EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM5RST},
    {CHIP_PER_ID_TIM6,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM6EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM6RST},
    {CHIP_PER_ID_TIM7,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM7EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM7RST},
    {CHIP_PER_ID_TIM12,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM12EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM12RST},
    {CHIP_PER_ID_TIM13,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM13EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM13RST},
    {CHIP_PER_ID_TIM14,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_TIM14EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_TIM14RST},
#if CHIP_CLK_LPTIM1_KER_SRC_EN
    {CHIP_PER_ID_LPTIM1,    &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_LPTIM1EN, &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_LPTIM1RST},
#endif
#if CHIP_DEV_SUPPORT_CORE_CM4
    {CHIP_PER_ID_WWDG2,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_WWDG2EN,  NULL, 0},
#endif
#if CHIP_CLK_SPI1_2_3_KER_SRC_EN
    {CHIP_PER_ID_SPI2,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_SPI2EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_SPI2RST},
    {CHIP_PER_ID_SPI3,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_SPI3EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_SPI3RST},
#endif
#if CHIP_CLK_SPDIFRX_KER_SRC_EN
    {CHIP_PER_ID_SPDIFRX,   &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_SPDIFRXEN,&CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_SPDIFRXRST},
#endif
#if CHIP_CLK_USART2_3_4_5_7_8_KER_SRC_EN
    {CHIP_PER_ID_USART2,    &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_USART2EN, &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_USART2RST},
    {CHIP_PER_ID_USART3,    &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_USART3EN, &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_USART3RST},
    {CHIP_PER_ID_UART4,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_UART4EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_UART4RST},
    {CHIP_PER_ID_UART5,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_UART5EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_UART5RST},
#endif
#if CHIP_CLK_I2C1_2_3_5_KER_SRC_EN
    {CHIP_PER_ID_I2C1,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_I2C1EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_I2C1RST},
    {CHIP_PER_ID_I2C2,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_I2C2EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_I2C2RST},
    {CHIP_PER_ID_I2C3,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_I2C3EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_I2C3RST},
#if CHIP_DEV_SUPPORT_I2C5
    {CHIP_PER_ID_I2C5,      &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_I2C5EN,   &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_I2C5RST},
#endif
#endif
#if CHIP_CLK_CEC_KER_SRC_EN
    {CHIP_PER_ID_CEC,       &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_CECEN,    &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_CECRST},
#endif
    {CHIP_PER_ID_DAC12,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_DAC12EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_DAC12RST},
#if CHIP_CLK_USART2_3_4_5_7_8_KER_SRC_EN
    {CHIP_PER_ID_UART7,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_UART7EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_UART7RST},
    {CHIP_PER_ID_UART8,     &CHIP_REGS_RCC->APB1LENR,CHIP_REGFLD_RCC_APB1LENR_UART8EN,  &CHIP_REGS_RCC->APB1LRSTR,CHIP_REGFLD_RCC_APB1LRSTR_UART8RST},
#endif
    {CHIP_PER_ID_CRS,       &CHIP_REGS_RCC->APB1HENR,CHIP_REGFLD_RCC_APB1HENR_CRSEN,    &CHIP_REGS_RCC->APB1HRSTR,CHIP_REGFLD_RCC_APB1HRSTR_CRSRST},
#if CHIP_CLK_SWPMI_KER_SRC_EN
    {CHIP_PER_ID_SWPMI,     &CHIP_REGS_RCC->APB1HENR,CHIP_REGFLD_RCC_APB1HENR_SWPMIEN,  &CHIP_REGS_RCC->APB1HRSTR,CHIP_REGFLD_RCC_APB1HRSTR_SWPMIRST},
#endif
    {CHIP_PER_ID_OPAMP,     &CHIP_REGS_RCC->APB1HENR,CHIP_REGFLD_RCC_APB1HENR_OPAMPEN,  &CHIP_REGS_RCC->APB1HRSTR,CHIP_REGFLD_RCC_APB1HRSTR_OPAMPRST},
    {CHIP_PER_ID_MDIOS,     &CHIP_REGS_RCC->APB1HENR,CHIP_REGFLD_RCC_APB1HENR_MDIOSEN,  &CHIP_REGS_RCC->APB1HRSTR,CHIP_REGFLD_RCC_APB1HRSTR_MDIOSRST},
#if CHIP_CLK_FDCAN_KER_SRC_EN
    {CHIP_PER_ID_FDCAN,     &CHIP_REGS_RCC->APB1HENR,CHIP_REGFLD_RCC_APB1HENR_FDCANEN,  &CHIP_REGS_RCC->APB1HRSTR,CHIP_REGFLD_RCC_APB1HRSTR_FDCANRST},
#endif
#if CHIP_DEV_SUPPORT_TIM23_24
    {CHIP_PER_ID_TIM23,     &CHIP_REGS_RCC->APB1HENR,CHIP_REGFLD_RCC_APB1HENR_TIM23EN,  &CHIP_REGS_RCC->APB1HRSTR,CHIP_REGFLD_RCC_APB1HRSTR_TIM23RST},
    {CHIP_PER_ID_TIM24,     &CHIP_REGS_RCC->APB1HENR,CHIP_REGFLD_RCC_APB1HENR_TIM24EN,  &CHIP_REGS_RCC->APB1HRSTR,CHIP_REGFLD_RCC_APB1HRSTR_TIM24RST},
#endif
    {CHIP_PER_ID_TIM1,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_TIM1EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_TIM1RST},
    {CHIP_PER_ID_TIM8,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_TIM8EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_TIM8RST},
#if CHIP_CLK_USART1_6_9_10_KER_SRC_EN
    {CHIP_PER_ID_USART1,    &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_USART1EN,  &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_USART1RST},
    {CHIP_PER_ID_USART6,    &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_USART6EN,  &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_USART6RST},
#if CHIP_DEV_SUPPORT_USART9_10
    {CHIP_PER_ID_UART9,     &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_UART9EN,   &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_UART9RST},
    {CHIP_PER_ID_USART10,   &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_USART10EN, &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_USART10RST},
#endif
#endif
#if CHIP_CLK_SPI1_2_3_KER_SRC_EN
    {CHIP_PER_ID_SPI1,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_SPI1EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_SPI1RST},
#endif
#if CHIP_CLK_SPI4_5_KER_SRC_EN
    {CHIP_PER_ID_SPI4,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_SPI4EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_SPI4RST},
#endif
    {CHIP_PER_ID_TIM15,     &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_TIM15EN,   &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_TIM15RST},
    {CHIP_PER_ID_TIM16,     &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_TIM16EN,   &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_TIM16RST},
    {CHIP_PER_ID_TIM17,     &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_TIM17EN,   &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_TIM17RST},
#if CHIP_CLK_SPI4_5_KER_SRC_EN
    {CHIP_PER_ID_SPI5,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_SPI5EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_SPI5RST},
#endif
#if CHIP_CLK_SAI1_KER_SRC_EN
    {CHIP_PER_ID_SAI1,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_SAI1EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_SAI1RST},
#endif
#if CHIP_CLK_SAI2_3_KER_SRC_EN
    {CHIP_PER_ID_SAI2,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_SAI2EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_SAI2RST},
    {CHIP_PER_ID_SAI3,      &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_SAI3EN,    &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_SAI3RST},
#endif
#if CHIP_CLK_DFSDM1_KER_SRC_EN
    {CHIP_PER_ID_DFSDM1,    &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_DFSDM1EN,  &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_DFSDM1RST},
#endif
#if CHIP_DEV_SUPPORT_HRTIM
    {CHIP_PER_ID_HRTIM,     &CHIP_REGS_RCC->APB2ENR, CHIP_REGFLD_RCC_APB2ENR_HRTIMEN,   &CHIP_REGS_RCC->APB2RSTR, CHIP_REGFLD_RCC_APB2RSTR_HRTIMRST},
#endif
    {CHIP_PER_ID_SYSCFG,    &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_SYSCFGEN,  &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_SYSCFGRST},
#if CHIP_CLK_LPUART1_KER_SRC_EN
    {CHIP_PER_ID_LPUART1,   &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_LPUART1EN, &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_LPUART1RST},
#endif
#if CHIP_CLK_SPI6_KER_SRC_EN
    {CHIP_PER_ID_SPI6,      &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_SPI6EN,    &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_SPI6RST},
#endif
#if CHIP_CLK_I2C4_KER_SRC_EN
    {CHIP_PER_ID_I2C4,      &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_I2C4EN,    &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_I2C4RST},
#endif
#if CHIP_CLK_LPTIM2_KER_SRC_EN
    {CHIP_PER_ID_LPTIM2,    &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_LPTIM2EN,  &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_LPTIM2RST},
#endif
#if CHIP_CLK_LPTIM3_4_5_KER_SRC_EN
    {CHIP_PER_ID_LPTIM3,    &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_LPTIM3EN,  &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_LPTIM3RST},
    {CHIP_PER_ID_LPTIM4,    &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_LPTIM4EN,  &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_LPTIM4RST},
    {CHIP_PER_ID_LPTIM5,    &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_LPTIM5EN,  &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_LPTIM5RST},
#endif
    {CHIP_PER_ID_COMP12,    &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_COMP12EN,  &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_COMP12RST},
    {CHIP_PER_ID_VREF,      &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_VREFEN,    &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_VREFRST},
    {CHIP_PER_ID_RTC_APB,   &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_RTCAPBEN,  NULL, 0},
#if CHIP_CLK_SAI4_KER_SRC_EN
    {CHIP_PER_ID_SAI4,      &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_SAI4EN,    &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_SAI4RST},
#endif
#if CHIP_DEV_SUPPORT_DTS
    {CHIP_PER_ID_DTS,       &CHIP_REGS_RCC->APB4ENR, CHIP_REGFLD_RCC_APB4ENR_DTSEN,     &CHIP_REGS_RCC->APB4RSTR, CHIP_REGFLD_RCC_APB4RSTR_DTSRST},
#endif
};



static const t_per_regs *get_per_regs(t_chip_per_id id) {
    const t_per_regs *ret = 0;
    for (unsigned i = 0; i < sizeof(f_per_regs)/sizeof(f_per_regs[0]); i++) {
        if (f_per_regs[i].id == id) {
            ret = &f_per_regs[i];
            break;
        }
    }
    return ret;
}

void chip_per_rst(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->rst_reg) {
        *reg->rst_reg |= reg->rst_bit;
        chip_dmb();
        *reg->rst_reg &= ~reg->rst_bit;
        chip_dsb();
    }
}

void chip_per_clk_en(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg)
        *reg->clk_reg |= reg->clk_bit;
}

void chip_per_clk_dis(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg)
        *reg->clk_reg &= ~reg->clk_bit;
}

int chip_per_clk_is_en(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    return  reg && reg->clk_reg && ((*reg->clk_reg & reg->clk_bit) != 0);
}
